Package weka.knowledgeflow.steps

# Interface BaseStepExtender

All Known Implementing Classes:
  `AlterRelationName`, `Appender`, `ASEvaluator`, `ASSearchStrategy`, `Associator`, `AttributeSummarizer`, `BaseSimpleDataVisualizer`, `BaseStep`, `Block`, `BoundaryPlotter`, `ClassAssigner`, `Classifier`, `ClassifierPerformanceEvaluator`, `ClassValuePicker`, `Clusterer`, `ClustererPerformanceEvaluator`, `CostBenefitAnalysis`, `CrossValidationFoldMaker`, `DataGenerator`, `DataGrid`, `DataVisualizer`, `Dummy`, `ExecuteProcess`, `Filter`, `FlowByExpression`, `GetDataFromResult`, `GraphViewer`, `ImageSaver`, `ImageViewer`, `IncrementalClassifierEvaluator`, `InstanceStreamToBatchMaker`, `Job`, `Join`, `Loader`, `MakeResourceIntensive`, `MemoryBasedDataSource`, `ModelPerformanceChart`, `Note`, `PredictionAppender`, `Saver`, `ScatterPlotMatrix`, `SendToPerspective`, `SerializedModelSaver`, `SetPropertiesFromEnvironment`, `SetVariables`, `Sorter`, `StorePropertiesInEnvironment`, `StripChart`, `SubstringLabeler`, `SubstringReplacer`, `TestSetMaker`, `TextSaver`, `TextViewer`, `TrainingSetMaker`, `TrainTestSplitMaker`, `WekaAlgorithmWrapper`, `WriteDataToResult`, `WriteWekaLog`

public interface BaseStepExtender
A minimal set of methods, duplicated from the Step interface, that a simple subclass of BaseStep would need to implement in order to function as a start and/or main processing step in the Knowledge Flow.

Version:
  $Revision: $
Author:
  Mark Hall (mhall{[at]}pentaho{[dot]}com)
See Also:
  - `Step`
  - `BaseStep`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `List<String>`
  `getIncomingConnectionTypes()`
  Get a list of incoming connection types that this step can accept.
  `List<String>`
  `getOutgoingConnectionTypes()`
  Get a list of outgoing connection types that this step can produce.
  `void`
  `processIncoming(Data data)`
  Process an incoming data payload (if the step accepts incoming connections).
  `void`
  `start()`
  Start executing (if this component is a start point).
  `void`
  `stepInit()`
  Initialize the step.

- ## Method Details

  - ### stepInit

    void stepInit() throws WekaException
    Initialize the step.
    Throws:
      `WekaException` - if a problem occurs during initialization

  - ### getIncomingConnectionTypes

    List<String> getIncomingConnectionTypes()
    Get a list of incoming connection types that this step can accept. Ideally (and if appropriate), this should take into account the state of the step and any existing incoming connections. E.g. a step might be able to accept one (and only one) incoming batch data connection.
    Returns:
      a list of incoming connections that this step can accept given its current state

  - ### getOutgoingConnectionTypes

    List<String> getOutgoingConnectionTypes()
    Get a list of outgoing connection types that this step can produce. Ideally (and if appropriate), this should take into account the state of the step and the incoming connections. E.g. depending on what incoming connection is present, a step might be able to produce a trainingSet output, a testSet output or neither, but not both.
    Returns:
      a list of outgoing connections that this step can produce

  - ### start

    void start() throws WekaException
    Start executing (if this component is a start point). Either this method, processIncoming(), or both must be implemented.
    Throws:
      `WekaException` - if a problem occurs

  - ### processIncoming

    void processIncoming(Data data) throws WekaException
    Process an incoming data payload (if the step accepts incoming connections). Either this method, start(), or both must be implemented.
    Parameters:
      `data` - the payload to process
    Throws:
      `WekaException` - if a problem occurs